<?php

include_once('./include/config.php');
include('./include/xml2array.php');

// generating the appropriate dirs
mkdir($GLOBALS['CONFIG']['temp_dir'] . '/dining/', '0777');
mkdir($GLOBALS['CONFIG']['web_dir'] . '/dining/', '0777');

$output = array();
$spaces = array("    ", "   ", "  "); // whoever made foodpro doesn't know proper formatting of english...
$locations = array("01","04","05","11");
$meal_names = array("breakfast","lunch","dinner", "knight room");

for ($i = 0; $i < count($locations); $i++)
{
   // for now, we're just gonna get the location configuration
   $result = file_get_contents('http://dining1.rutgers.edu/FoodPro/menu.asp?LocationNUM=' . $locations[$i]);
   $result = xml2array($result);

   $output[$i]['location_name'] = $result['rss']['channel']['location']['value'];
   $output[$i]['date'] = date("D, M j, Y");

   for ($j = 0; $j < count($meal_names); $j++)
   {
      $output[$i]['meals'][$j]['meal_name'] = ucwords($meal_names[$j]);

      $result = file_get_contents('http://dining1.rutgers.edu/FoodPro/menu.asp?LocationNUM=' . $locations[$i] . '&mealName=' . urlencode(ucwords($meal_names[$j])));
      $result = xml2array($result);

      if (count($result['rss']['channel']['item']) == 0)
      {
         $output[$i]['meals'][$j]['meal_avail'] = false;
      } else
      {
         $output[$i]['meals'][$j]['meal_avail'] = true;
      }

      $k = -1;
      $r = 0;
      foreach ($result['rss']['channel']['item'] as $item)
      {
         if (preg_match("/--/", $item['description']['value']))
         {
            $k++;
            $output[$i]['meals'][$j]['genres'][$k]['genre_name'] = str_replace($spaces, " and ", ucwords(strtolower(trim(preg_replace("/--/","",$item['description']['value'])))));
            $r = 0;
         } else {
            $output[$i]['meals'][$j]['genres'][$k]['items'][$r] = str_replace($spaces, " ", ucwords(strtolower($item['description']['value'])));
            $r++;
         }
      }
   }
}

// we need to make sure data is good from FoodPro, if not, we won't write to file.
$broken = false;
for($i = 0; $i < count($locations); $i++)
{
   if ($output[$i]['location_name'] == null)
   {
      $broken = true;
   }
}


if (!$broken)
{
   $output = json_encode($output);

   $file = fopen($GLOBALS['CONFIG']['temp_dir'] . '/dining/rutgers-dining.txt', 'w');
   fwrite($file, $output);
   fclose($file);
   chmod($GLOBALS['CONFIG']['temp_dir'] . '/dining/rutgers-dining.txt', 0644);
   rename($GLOBALS['CONFIG']['temp_dir'] . '/dining/rutgers-dining.txt',$GLOBALS['CONFIG']['web_dir'] . '/dining/rutgers-dining.txt');
}
?>
